## rust-coreutils 0.5.0

=== crc-fast/Makefile ===
PROJECT_NAME := crc_fast

# Detect operating system
UNAME_S := $(shell uname -s)

# Determine OS-specific variables
ifeq ($(UNAME_S),Linux)
	DESTDIR ?= /usr/local
    LIB_EXTENSION := so
    STATIC_LIB_EXTENSION := a
    INSTALL_LIB_DIR := /lib
    INSTALL_BIN_DIR := /bin
    INSTALL_INCLUDE_DIR := /include
    POST_INSTALL := ldconfig
else ifeq ($(UNAME_S),Darwin)
    DESTDIR ?=
    # on macOS, there's not really a default location, so require DESTDIR
    ifeq ($(DESTDIR),)
        $(error On macOS, DESTDIR must be set for installation. Common locations include /usr/local or /opt/homebrew)
    endif
    LIB_EXTENSION := dylib
    STATIC_LIB_EXTENSION := a
    INSTALL_LIB_DIR := /lib
    INSTALL_BIN_DIR := /bin
    INSTALL_INCLUDE_DIR := /include
    POST_INSTALL := true
else
    # Windows
    DESTDIR ?=
    ifeq ($(DESTDIR),)
        $(error On Windows, DESTDIR must be set for installation. Common locations include C:\)
    endif
    LIB_EXTENSION := dll
    STATIC_LIB_EXTENSION := lib
    # Use relative paths when DESTDIR is set to avoid path joining issues
    PREFIX ?= Program Files\\$(PROJECT_NAME)
    INSTALL_LIB_DIR := $(PREFIX)\\bin
    INSTALL_BIN_DIR := $(PREFIX)\\bin
    INSTALL_INCLUDE_DIR := $(PREFIX)\\include
    POST_INSTALL := true
endif

# Library name with extension
LIB_NAME := lib$(PROJECT_NAME).$(LIB_EXTENSION)
STATIC_LIB_NAME := lib$(PROJECT_NAME).$(STATIC_LIB_EXTENSION)

# CLI binaries
CLI_BINARIES := checksum arch-check get-custom-params

# Default target
.PHONY: all
all: build

# Build the library using Cargo
.PHONY: build
build: test
	cargo build --all-features --release

# Test the library using Cargo
.PHONY: test
test:
	cargo test --all-features

# Install the library and headers
.PHONY: install
install: print-paths build
	@install -d $(DESTDIR)$(INSTALL_LIB_DIR)
	@install -d $(DESTDIR)$(INSTALL_BIN_DIR)
	@install -d $(DESTDIR)$(INSTALL_INCLUDE_DIR)

	install -m 644 target/release/$(LIB_NAME) $(DESTDIR)$(INSTALL_LIB_DIR)/
	install -m 644 target/release/$(STATIC_LIB_NAME) $(DESTDIR)$(INSTALL_LIB_DIR)/

	install -m 644 lib$(PROJECT_NAME).h $(DESTDIR)$(INSTALL_INCLUDE_DIR)/

	@for bin in $(CLI_BINARIES); do \
		install -m 755 target/release/$$bin $(DESTDIR)$(INSTALL_BIN_DIR)/; \
	done

	@if [ -z "$(DESTDIR)" ] && [ "$(POST_INSTALL)" != "true" ]; then \
		$(POST_INSTALL); \
	fi

# Uninstall the library and headers
.PHONY: uninstall
uninstall: print-paths
	rm -f $(DESTDIR)$(INSTALL_LIB_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)$(INSTALL_LIB_DIR)/$(STATIC_LIB_NAME)
	rm -f $(DESTDIR)$(INSTALL_INCLUDE_DIR)/lib$(PROJECT_NAME).h

	@for bin in $(CLI_BINARIES); do \
		rm -f $(DESTDIR)$(INSTALL_BIN_DIR)/$$bin; \
	done

	@if [ -z "$(DESTDIR)" ] && [ "$(UNAME_S)" = "Linux" ]; then \
		ldconfig; \
	fi

# Clean build artifacts
.PHONY: clean
clean:
	cargo clean

# Print installation paths (useful for debugging)
.PHONY: print-paths
print-paths:
	@echo "Installation paths:"
	@echo "Library dir: $(DESTDIR)$(INSTALL_LIB_DIR)"
	@echo "Binary dir: $(DESTDIR)$(INSTALL_BIN_DIR)"
	@echo "Include dir: $(DESTDIR)$(INSTALL_INCLUDE_DIR)"

=== debian/changelog ===
rust-coreutils (0.5.0-0ubuntu2) resolute; urgency=medium

  * Add and install l10n translation files.

 -- Simon Johnsson <simon.johnsson@canonical.com>  Fri, 30 Jan 2026 14:33:41 +0100

rust-coreutils (0.5.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (LP: #2138304)
  * Change applied patches:
    - Tweak-release-build-profile: Remove panic = "abort"
      in Cargo.toml as it is already set by default.
    - workspace-exclude: Remove tests/benches as it no
      longer exists upstream.
  * Skip failing 0.5.0 tests (LP: #2138377)
  * Enable passing 0.5.0 tests

 -- Simon Johnsson <simon.johnsson@canonical.com>  Mon, 12 Jan 2026 15:23:49 +0100

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo:native,
 rustc:native,
 libselinux1-dev,
 libclang-dev,
 python3-sphinx,
XS-Vendored-Sources-Rust: adler2@2.0.1, aho-corasick@1.1.3, allocator-api2@0.2.21, ansi-width@0.1.0, anstream@0.6.19, anstyle-parse@0.2.7, anstyle-query@1.1.3, anstyle@1.0.11, anyhow@1.0.100, approx@0.5.1, arrayref@0.3.9, arrayvec@0.7.6, autocfg@1.4.0, base64-simd@0.8.0, bigdecimal@0.4.9, binary-heap-plus@0.5.0, bincode@2.0.1, bincode_derive@2.0.1, bindgen@0.72.1, bitflags@2.9.1, bitvec@1.0.1, blake2b_simd@1.0.3, blake3@1.8.2, block-buffer@0.10.4, bstr@1.12.1, bumpalo@3.18.1, bytecount@0.6.9, byteorder@1.5.0, cc@1.2.27, cexpr@0.6.0, cfg-if@1.0.1, cfg_aliases@0.2.1, chrono@0.4.42, clang-sys@1.8.1, clap@4.5.53, clap_builder@4.5.53, clap_complete@4.5.61, clap_lex@0.7.5, clap_mangen@0.2.31, codspeed-divan-compat-macros@4.1.0, codspeed-divan-compat-walltime@4.1.0, codspeed-divan-compat@4.1.0, codspeed@4.1.0, colorchoice@1.0.4, colored@2.2.0, compare@0.1.0, condtype@1.3.0, console@0.16.0, const-random-macro@0.1.16, const-random@0.1.18, constant_time_eq@0.3.1, convert_case@0.7.1, cpufeatures@0.2.17, crc-catalog@2.4.0, crc-fast@1.8.1, crc32fast@1.5.0, crc@3.3.0, crossbeam-deque@0.8.6, crossbeam-epoch@0.9.18, crossbeam-utils@0.8.21, crossterm@0.29.0, crunchy@0.2.3, crypto-common@0.1.6, ctor-proc-macro@0.0.7, ctor@0.6.3, ctrlc@3.4.7, data-encoding-macro-internal@0.1.16, data-encoding-macro@0.1.18, data-encoding@2.9.0, deranged@0.5.2, derive_more-impl@2.0.1, derive_more@2.0.1, diff@0.1.13, digest@0.10.7, displaydoc@0.2.5, divan-macros@0.1.17, dlv-list@0.5.2, dns-lookup@3.0.1, document-features@0.2.11, dtor-proc-macro@0.0.6, dtor@0.1.0, dunce@1.0.5, either@1.15.0, equivalent@1.0.2, errno@0.3.12, exacl@0.12.0, fastrand@2.3.0, file_diff@1.0.0, filedescriptor@0.8.3, filetime@0.2.26, fixed_decimal@0.7.0, flate2@1.1.2, fluent-bundle@0.16.0, fluent-langneg@0.13.0, fluent-syntax@0.12.0, fluent@0.17.0, fnv@1.0.7, foldhash@0.1.5, fs_extra@1.3.0, fts-sys@0.2.17, funty@2.0.0, futures-core@0.3.31, futures-macro@0.3.31, futures-task@0.3.31, futures-timer@3.0.3, futures-util@0.3.31, gcd@2.3.0, generic-array@0.14.7, getrandom@0.2.16, getrandom@0.3.3, glob@0.3.3, half@2.7.1, hashbrown@0.14.5, hashbrown@0.15.4, hex-literal@1.1.0, hex@0.4.3, hostname@0.4.2, iana-time-zone@0.1.64, icu_collator@2.1.1, icu_collator_data@2.1.1, icu_collections@2.1.1, icu_decimal@2.1.1, icu_decimal_data@2.1.1, icu_locale@2.1.1, icu_locale_core@2.1.1, icu_locale_data@2.1.1, icu_normalizer@2.1.1, icu_normalizer_data@2.1.1, icu_properties@2.1.1, icu_properties_data@2.1.1, icu_provider@2.1.1, indexmap@2.9.0, indicatif@0.18.3, inotify-sys@0.1.5, inotify@0.11.0, intl-memoizer@0.5.3, intl_pluralrules@7.0.2, is_terminal_polyfill@1.70.1, itertools@0.13.0, itertools@0.14.0, itoa@1.0.15, jiff-static@0.2.16, jiff@0.2.16, keccak@0.1.5, lazy_static@1.5.0, libc@0.2.175, libloading@0.8.8, libm@0.2.15, libz-rs-sys@0.5.1, linux-raw-sys@0.11.0, linux-raw-sys@0.12.0, litemap@0.8.0, litrs@0.4.1, lock_api@0.4.13, log@0.4.27, lru@0.12.5, lscolors@0.21.0, md-5@0.10.6, memchr@2.7.6, memmap2@0.9.9, memoffset@0.9.1, minimal-lexical@0.2.1, miniz_oxide@0.8.9, mio@1.0.4, nix@0.30.1, nom@7.1.3, nom@8.0.0, notify-types@2.0.0, notify@8.2.0, nu-ansi-term@0.50.3, num-bigint@0.4.6, num-conv@0.1.0, num-integer@0.1.46, num-modular@0.5.1, num-prime@0.4.4, num-traits@0.2.19, num_threads@0.1.7, once_cell@1.21.3, onig@6.5.1, onig_sys@69.9.1, ordered-multimap@0.7.3, os_display@0.1.4, outref@0.5.2, parking_lot@0.12.4, parking_lot_core@0.9.11, parse_datetime@0.13.3, phf@0.13.1, phf_codegen@0.13.1, phf_generator@0.13.1, phf_shared@0.13.1, pin-project-lite@0.2.16, pin-utils@0.1.0, pkg-config@0.3.32, platform-info@2.0.5, portable-atomic@1.11.1, potential_utf@0.1.4, powerfmt@0.2.0, ppv-lite86@0.2.21, pretty_assertions@1.4.1, prettyplease@0.2.34, proc-macro-crate@3.3.0, proc-macro2@1.0.103, procfs-core@0.18.0, procfs@0.18.0, quote@1.0.42, radium@0.7.0, rand@0.8.5, rand@0.9.2, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rayon-core@1.13.0, rayon@1.11.0, regex-automata@0.4.12, regex-lite@0.1.7, regex-syntax@0.8.5, regex@1.12.2, relative-path@1.9.3, rlimit@0.10.2, roff@0.2.2, rstest@0.26.1, rstest_macros@0.26.1, rust-ini@0.21.3, rustc-hash@2.1.1, rustc_version@0.4.1, rustix@1.1.2, rustversion@1.0.21, ryu@1.0.20, same-file@1.0.6, scopeguard@1.2.0, self_cell@1.2.1, selinux-sys@0.6.15, selinux@0.5.2, semver@1.0.26, serde-big-array@0.5.1, serde@1.0.228, serde_core@1.0.228, serde_derive@1.0.228, serde_json@1.0.140, sha1@0.10.6, sha2@0.10.9, sha3@0.10.8, shlex@1.3.0, signal-hook-mio@0.2.4, signal-hook-registry@1.4.5, signal-hook@0.3.18, simd-adler32@0.3.7, siphasher@1.0.1, slab@0.4.9, sm3@0.4.2, smallvec@1.15.1, smawk@0.3.2, socket2@0.6.0, spin@0.10.0, stable_deref_trait@1.2.0, statrs@0.18.0, strsim@0.11.1, syn@2.0.103, synstructure@0.13.2, tap@1.0.1, tempfile@3.23.0, terminal_size@0.4.3, textwrap@0.16.2, thiserror-impl@1.0.69, thiserror-impl@2.0.17, thiserror@1.0.69, thiserror@2.0.17, time-core@0.1.6, time-macros@0.2.24, time@0.3.44, tiny-keccak@2.0.2, tinystr@0.8.1, toml_datetime@0.6.11, toml_edit@0.22.27, type-map@0.5.1, typenum@1.18.0, unic-langid-impl@0.9.6, unic-langid@0.9.6, unicode-ident@1.0.18, unicode-linebreak@0.1.5, unicode-segmentation@1.12.0, unicode-width@0.1.14, unicode-width@0.2.2, unindent@0.2.4, unit-prefix@0.5.2, unty@0.0.4, utf16_iter@1.0.5, utf8_iter@1.0.4, utf8parse@0.2.2, uuid@1.17.0, uutils_term_grid@0.7.0, version_check@0.9.5, virtue@0.0.18, vsimd@0.8.0, walkdir@2.5.0, winnow@0.7.11, write16@1.0.0, writeable@0.6.2, wyz@0.5.1, xattr@1.6.1, yansi@1.0.1, yoke-derive@0.8.0, yoke@0.8.0, z85@3.0.6, zerocopy-derive@0.8.27, zerocopy@0.8.27, zerofrom-derive@0.1.6, zerofrom@0.1.6, zerotrie@0.2.2, zerovec-derive@0.11.1, zerovec@0.11.5, zip@6.0.0, zlib-rs@0.5.1, zopfli@0.8.2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Conflicts:
 coreutils-from-uutils (<< 0.0.0~ubuntu22~)
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export CARGO_PROFILE_RELEASE_DEBUG=true
export LIBSTDBUF_DIR = /usr/libexec/rust-coreutils
VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")
UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version|cut -d- -f1)

# Build a multicall binary instead of multiple binaries
# to reduce the storage footprint
export MULTICALL = y

# Vendoring setup
# FIXME: The upstream Makefile we use doesn't work with the cargo wrapper,
# as it assumes no cross-compilation and hence files appearing in target/release
# rather than the architecture-specific target directory.
#export CARGO = /usr/share/cargo/bin/cargo
export CARGO_VENDOR_DIR = rust-vendor
export CARGO_HOME = $(CURDIR)/debian/cargo_home

# Build verbosely
export CARGOFLAGS = -v

VENDOR_TARBALL = rust-coreutils_$(UPSTREAM_VERSION).orig-$(CARGO_VENDOR_DIR).tar.xz

%:
	dh $@ --buildsystem cargo

vendor-tarball-quick-check:
	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi

vendor-deps-cargo:
	rm -rf $(CARGO_VENDOR_DIR)
	# Deliberately don't use the wrapper, as it expects the configure step
	# to have occurred already.
	# If you have to modify the path here, don't forget to change the README.source doc
	# as well.
	env -i cargo-vendor-filterer --all-features  --tier 2  --platform '*-*-linux-gnu' --platform '*-*-linux-gnueabi' $(CARGO_VENDOR_DIR)

vendor-deps: vendor-deps-cargo
	rm -r \
		$(CARGO_VENDOR_DIR)/*/tests
	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
	for crate in $(CARGO_VENDOR_DIR)/*; do \
		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
		done
	# Cleanup temp files
	rm -rf $(CARGO_HOME)

vendor-tarball: vendor-tarball-quick-check vendor-deps
	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)

override_dh_auto_configure:
	if [ ! -d l10n/ ]; then \
		echo "Error: l10n translations not found! Run uscan -dd to download the l10n tarball." >&2; \
        exit 1; \
    fi
	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian $(CARGO_VENDOR_DIR)
	/usr/share/cargo/bin/dh-cargo-vendored-sources
	dh_auto_configure

override_dh_auto_test:
	CARGO_HOME=$(CURDIR)/debian/cargo_home make PROFILE=release MULTICALL=$(MULTICALL) \
				TEST_NO_FAIL_FAST="-- --skip test_env::test_env_arg_ignore_signal_valid_signals \
				--skip test_env::test_env_french \
				--skip test_env::test_simulation_of_terminal_for_stdin_only \
				--skip test_env::test_simulation_of_terminal_size_information \
				--skip test_env::test_simulation_of_terminal_true \
				--skip test_expr::test_long_input \
				--skip test_factor::test_parallel \
				--skip test_chown::test_chown_only_group_id_nonexistent_group \
				--skip test_chown::test_chown_only_user_id_nonexistent_user \
				--skip test_chmod::test_chmod_colored_output \
				--skip test_install::test_install_and_strip \
				--skip test_install::test_install_and_strip_with_program \
				--skip test_ls::test_device_number \
				--skip test_ls::test_localized_possible_values \
				--skip test_od::test_od_options_after_filename \
				--skip test_od::test_suppress_duplicates \
				--skip test_sort::test_argument_suggestion \
				--skip test_sort::test_clap_localization_help_message \
				--skip test_sort::test_clap_localization_invalid_value \
				--skip test_sort::test_clap_localization_unknown_argument \
				--skip test_sort::test_error_colors_disabled \
				--skip test_sort::test_error_colors_enabled \
				--skip test_sort::test_french_translations \
				--skip test_sort::test_help_colors_disabled \
				--skip test_sort::test_help_colors_enabled \
				--skip test_stat::test_mount_point_basic \
				--skip test_stat::test_mount_point_combined_with_other_specifiers \
				--skip test_stat::test_multi_files \
				--skip test_stat::test_normal_format \
				--skip test_stat::test_printf \
				--skip test_stat::test_symlinks \
				--skip test_stat::test_terse_fs_format \
				--skip test_tail::test_following_with_pid \
				--skip test_tail::test_follow_when_files_are_pointing_to_same_relative_file_and_file_stays_same_size stdout \
				--skip test_error_messages_french_translation \
				--skip test_french_colored_error_messages \
				--skip test_help_messages_french_translation \
				--skip util_invalid_name_invalid_command" \
				test

override_dh_auto_install:
#use thin rather than full lto on 32-bit to avoid running out of address space.
ifeq ($(DEB_HOST_ARCH_BITS),32)
	sed -i 's/lto = true/lto = "thin"/' Cargo.toml
endif
	CARGO_HOME=$(CURDIR)/debian/cargo_home DESTDIR=$(CURDIR)/debian/tmp/ make SELINUX_ENABLED=1 PROFILE=release MULTICALL=$(MULTICALL) install
ifeq ($(DEB_HOST_ARCH_BITS),32)
	sed -i 's/lto = "thin"/lto = true/' Cargo.toml
endif
# Create the symlink early to be able to generate the manpages
	cd debian/tmp/usr/share/zsh/site-functions && mkdir rust-coreutils && chmod -x _* && mv _* rust-coreutils
	cd debian/tmp/usr/share/bash-completion/completions/ && chmod -x rust-*
	cd debian/tmp/usr/share/fish/vendor_completions.d/ && chmod -x *.fish
	cd debian/tmp/usr/bin && mv rust-coreutils coreutils && rm rust-*
#	cd debian/tmp/usr/share/fish/vendor_completions.d && for f in *fish; do mv $$f rust-$$f; done
#

execute_after_dh_install:
	install -d debian/rust-coreutils/usr/lib/cargo/bin/coreutils
	cat debian/rust-coreutils.hardlinks | while read a b; do \
		env -C debian/rust-coreutils/ ln $$a $$b; \
	done

override_dh_missing:
	dh_missing --fail-missing

override_dh_dwz:
	# Don't do anything. fails because of the
	# https://github.com/rust-lang/rust/issues/66118

#use lower debuginfo level on 32-bit to avoid running out of address space.
ifeq ($(DEB_HOST_ARCH_BITS),32)
execute_after_dh_auto_configure:
	if test -f debian/cargo_home/config; then \
		sed -i s/debuginfo=2/debuginfo=1/ debian/cargo_home/config; \
	fi
endif

override_dh_clean:
	rm -f Cargo.toml.orig Cargo.lock
	dh_clean

=== debian/watch ===
Version: 5

Template: GitHub
Dist: https://github.com/uutils/coreutils

Template: GitHub
Component: l10n
Dist: https://github.com/uutils/coreutils-l10n

## rust-coreutils 0.6.0

=== crc-fast/Makefile ===
--- 
+++ 
@@ -96,6 +96,16 @@
 		ldconfig; \
 	fi
 
+# Run all code quality checks
+.PHONY: check
+check:
+	cargo fmt --all
+	cargo check --workspace --all-targets --all-features
+	cargo clippy --workspace --all-targets --all-features --fix --allow-dirty -- -D warnings
+#	cargo deny check all
+#	RUSTDOCFLAGS="-D warnings" cargo doc --workspace --no-deps --all-features
+#	cargo audit
+
 # Clean build artifacts
 .PHONY: clean
 clean:

=== blake3/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9...3.18 FATAL_ERROR)

# respect C_EXTENSIONS OFF without explicitly setting C_STANDARD
if (POLICY CMP0128)
  cmake_policy(SET CMP0128 NEW)
endif()
# mark_as_advanced does not implicitly create UNINITIALIZED cache entries
if (POLICY CMP0102)
  cmake_policy(SET CMP0102 NEW)
endif()

project(libblake3
  VERSION 1.8.3
  DESCRIPTION "BLAKE3 C implementation"
  LANGUAGES C CXX ASM
)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option(BLAKE3_USE_TBB "Enable oneTBB parallelism" OFF)
option(BLAKE3_FETCH_TBB "Allow fetching oneTBB from GitHub if not found on system" OFF)

include(CTest)
include(FeatureSummary)
include(GNUInstallDirs)
include(BLAKE3/Utils)

add_subdirectory(dependencies)

# architecture lists for which to enable assembly / SIMD sources
set(BLAKE3_AMD64_NAMES amd64 AMD64 x86_64)
set(BLAKE3_X86_NAMES i686 x86 X86)
set(BLAKE3_ARMv8_NAMES aarch64 AArch64 arm64 ARM64 armv8 armv8a)
# default SIMD compiler flag configuration (can be overriden by toolchains or CLI)
if(MSVC)
  set(BLAKE3_CFLAGS_SSE2 "/arch:SSE2" CACHE STRING "the compiler flags to enable SSE2")
  # MSVC has no dedicated sse4.1 flag (see https://learn.microsoft.com/en-us/cpp/build/reference/arch-x86?view=msvc-170)
  set(BLAKE3_CFLAGS_SSE4.1 "/arch:AVX" CACHE STRING "the compiler flags to enable SSE4.1")
  set(BLAKE3_CFLAGS_AVX2 "/arch:AVX2" CACHE STRING "the compiler flags to enable AVX2")
  set(BLAKE3_CFLAGS_AVX512 "/arch:AVX512" CACHE STRING "the compiler flags to enable AVX512")

  set(BLAKE3_AMD64_ASM_SOURCES
    blake3_avx2_x86-64_windows_msvc.asm
    blake3_avx512_x86-64_windows_msvc.asm
    blake3_sse2_x86-64_windows_msvc.asm
    blake3_sse41_x86-64_windows_msvc.asm
  )

elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU"
       OR CMAKE_C_COMPILER_ID STREQUAL "Clang"
       OR CMAKE_C_COMPILER_ID STREQUAL "AppleClang")
  set(BLAKE3_CFLAGS_SSE2 "-msse2" CACHE STRING "the compiler flags to enable SSE2")
  set(BLAKE3_CFLAGS_SSE4.1 "-msse4.1" CACHE STRING "the compiler flags to enable SSE4.1")
  set(BLAKE3_CFLAGS_AVX2 "-mavx2" CACHE STRING "the compiler flags to enable AVX2")
  set(BLAKE3_CFLAGS_AVX512 "-mavx512f -mavx512vl" CACHE STRING "the compiler flags to enable AVX512")

  if (WIN32 OR CYGWIN)
    set(BLAKE3_AMD64_ASM_SOURCES
      blake3_avx2_x86-64_windows_gnu.S
      blake3_avx512_x86-64_windows_gnu.S
      blake3_sse2_x86-64_windows_gnu.S
      blake3_sse41_x86-64_windows_gnu.S
    )

  elseif(UNIX)
    set(BLAKE3_AMD64_ASM_SOURCES
      blake3_avx2_x86-64_unix.S
      blake3_avx512_x86-64_unix.S
      blake3_sse2_x86-64_unix.S
      blake3_sse41_x86-64_unix.S
    )
  endif()

  if (CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_ARMv8_NAMES
      AND NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    # 32-bit ARMv8 needs NEON to be enabled explicitly
    set(BLAKE3_CFLAGS_NEON "-mfpu=neon" CACHE STRING "the compiler flags to enable NEON")
  endif()
endif()

mark_as_advanced(BLAKE3_CFLAGS_SSE2 BLAKE3_CFLAGS_SSE4.1 BLAKE3_CFLAGS_AVX2 BLAKE3_CFLAGS_AVX512 BLAKE3_CFLAGS_NEON)
mark_as_advanced(BLAKE3_AMD64_ASM_SOURCES)

message(STATUS "BLAKE3 SIMD configuration: ${CMAKE_C_COMPILER_ARCHITECTURE_ID}")
if(MSVC AND DEFINED CMAKE_C_COMPILER_ARCHITECTURE_ID)
  if(CMAKE_C_COMPILER_ARCHITECTURE_ID MATCHES "[Xx]86")
    set(BLAKE3_SIMD_TYPE "x86-intrinsics" CACHE STRING "the SIMD acceleration type to use")

  elseif(CMAKE_C_COMPILER_ARCHITECTURE_ID MATCHES "[Xx]64")
    set(BLAKE3_SIMD_TYPE "amd64-asm" CACHE STRING "the SIMD acceleration type to use")

  elseif(CMAKE_C_COMPILER_ARCHITECTURE_ID MATCHES "[Aa][Rr][Mm]64")
    set(BLAKE3_SIMD_TYPE "neon-intrinsics" CACHE STRING "the SIMD acceleration type to use")

  else()
    set(BLAKE3_SIMD_TYPE "none" CACHE STRING "the SIMD acceleration type to use")
  endif()

elseif(CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_AMD64_NAMES)
  set(BLAKE3_SIMD_TYPE "amd64-asm" CACHE STRING "the SIMD acceleration type to use")

elseif(CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_X86_NAMES
       AND DEFINED BLAKE3_CFLAGS_SSE2
       AND DEFINED BLAKE3_CFLAGS_SSE4.1
       AND DEFINED BLAKE3_CFLAGS_AVX2
       AND DEFINED BLAKE3_CFLAGS_AVX512)
  set(BLAKE3_SIMD_TYPE "x86-intrinsics" CACHE STRING "the SIMD acceleration type to use")

elseif((CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_ARMv8_NAMES
          OR ANDROID_ABI STREQUAL "armeabi-v7a"
          OR BLAKE3_USE_NEON_INTRINSICS)
        AND (DEFINED BLAKE3_CFLAGS_NEON
          OR CMAKE_SIZEOF_VOID_P EQUAL 8))
  set(BLAKE3_SIMD_TYPE "neon-intrinsics" CACHE STRING "the SIMD acceleration type to use")

else()
  set(BLAKE3_SIMD_TYPE "none" CACHE STRING "the SIMD acceleration type to use")
endif()

mark_as_advanced(BLAKE3_SIMD_TYPE)

# library target
add_library(blake3
  blake3.c
  blake3_dispatch.c
  blake3_portable.c
)
add_library(BLAKE3::blake3 ALIAS blake3)

# library configuration
set(PKG_CONFIG_CFLAGS)
if (BUILD_SHARED_LIBS)
  target_compile_definitions(blake3
    PUBLIC BLAKE3_DLL
    PRIVATE BLAKE3_DLL_EXPORTS
  )
  list(APPEND PKG_CONFIG_CFLAGS -DBLAKE3_DLL)
endif()
target_include_directories(blake3 PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
set_target_properties(blake3 PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION 0
  C_VISIBILITY_PRESET hidden
  C_EXTENSIONS OFF
)
target_compile_features(blake3 PUBLIC c_std_99)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.12)
  target_compile_features(blake3 PUBLIC cxx_std_20)
  # else: add it further below through `BLAKE3_CMAKE_CXXFLAGS_*`
endif()

# ensure C_EXTENSIONS OFF is respected without overriding CMAKE_C_STANDARD
# which may be set by the user or toolchain file
if (NOT POLICY CMP0128 AND NOT DEFINED CMAKE_C_STANDARD)
  set_target_properties(blake3 PROPERTIES C_STANDARD 99)
endif()

# optional SIMD sources
if(BLAKE3_SIMD_TYPE STREQUAL "amd64-asm")
  if (NOT DEFINED BLAKE3_AMD64_ASM_SOURCES)
    message(FATAL_ERROR "BLAKE3_SIMD_TYPE is set to 'amd64-asm' but no assembly sources are available for the target architecture.")
  endif()
  set(BLAKE3_SIMD_AMD64_ASM ON)

  if(MSVC)
    enable_language(ASM_MASM)
  endif()

  target_sources(blake3 PRIVATE ${BLAKE3_AMD64_ASM_SOURCES})

elseif(BLAKE3_SIMD_TYPE STREQUAL "x86-intrinsics")
  if (NOT DEFINED BLAKE3_CFLAGS_SSE2
      OR NOT DEFINED BLAKE3_CFLAGS_SSE4.1
      OR NOT DEFINED BLAKE3_CFLAGS_AVX2
      OR NOT DEFINED BLAKE3_CFLAGS_AVX512)
    message(FATAL_ERROR "BLAKE3_SIMD_TYPE is set to 'x86-intrinsics' but no compiler flags are available for the target architecture.")
  endif()
  set(BLAKE3_SIMD_X86_INTRINSICS ON)

  target_sources(blake3 PRIVATE
    blake3_avx2.c
    blake3_avx512.c
    blake3_sse2.c
    blake3_sse41.c
  )
  set_source_files_properties(blake3_avx2.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_AVX2}")
  set_source_files_properties(blake3_avx512.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_AVX512}")
  set_source_files_properties(blake3_sse2.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_SSE2}")
  set_source_files_properties(blake3_sse41.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_SSE4.1}")

elseif(BLAKE3_SIMD_TYPE STREQUAL "neon-intrinsics")
  set(BLAKE3_SIMD_NEON_INTRINSICS ON)

  target_sources(blake3 PRIVATE
    blake3_neon.c
  )
  target_compile_definitions(blake3 PRIVATE
    BLAKE3_USE_NEON=1
  )

  if (DEFINED BLAKE3_CFLAGS_NEON)
    set_source_files_properties(blake3_neon.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_NEON}")
  endif()

elseif(BLAKE3_SIMD_TYPE STREQUAL "none")
  target_compile_definitions(blake3 PRIVATE
    BLAKE3_USE_NEON=0
    BLAKE3_NO_SSE2
    BLAKE3_NO_SSE41
    BLAKE3_NO_AVX2
    BLAKE3_NO_AVX512
  )

else()
  message(FATAL_ERROR "BLAKE3_SIMD_TYPE is set to an unknown value: '${BLAKE3_SIMD_TYPE}'")
endif()

if(BLAKE3_USE_TBB)
  find_package(TBB 2021.11.0 QUIET)
  if(NOT TBB_FOUND AND NOT TARGET TBB::tbb)
    message(WARNING
      "oneTBB not found; disabling BLAKE3_USE_TBB\n"
      "Enable BLAKE3_FETCH_TBB to automatically fetch and build oneTBB"
    )
    set(BLAKE3_USE_TBB OFF)
  else()
    target_sources(blake3
      PRIVATE
        blake3_tbb.cpp)
    target_link_libraries(blake3
      PUBLIC
        # Make shared TBB a transitive dependency. The consuming program is technically not required
        # to link TBB in order for libblake3 to function but we do this in order to prevent the
        # possibility of multiple separate TBB runtimes being linked into a final program in case
        # the consuming program also happens to already use TBB.
        TBB::tbb)
    target_compile_definitions(blake3
      PUBLIC
        BLAKE3_USE_TBB)
  endif()
  if (CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(TBB_PC_NAME tbb)
  else()
    set(TBB_PC_NAME tbb32)
  endif()
  list(APPEND PKG_CONFIG_REQUIRES "${TBB_PC_NAME} >= ${TBB_VERSION}")
  list(APPEND PKG_CONFIG_CFLAGS -DBLAKE3_USE_TBB)
  include(CheckCXXSymbolExists)
  check_cxx_symbol_exists(_LIBCPP_VERSION "version" BLAKE3_HAVE_LIBCPP)
  check_cxx_symbol_exists(__GLIBCXX__ "version" BLAKE3_HAVE_GLIBCXX)
  if(BLAKE3_HAVE_GLIBCXX)
    list(APPEND PKG_CONFIG_LIBS -lstdc++)
  elseif(BLAKE3_HAVE_LIBCPP)
    list(APPEND PKG_CONFIG_LIBS -lc++)
  endif()
endif()

if(BLAKE3_USE_TBB)
  # Define some scratch variables for building appropriate flags per compiler
  if(CMAKE_VERSION VERSION_LESS 3.12)
    set(APPEND BLAKE3_CXX_STANDARD_FLAGS_GNU -std=c++20)
    set(APPEND BLAKE3_CXX_STANDARD_FLAGS_MSVC /std:c++20)
  endif()

  set(BLAKE3_CXXFLAGS_GNU "-fno-exceptions;-fno-rtti;${BLAKE3_CXX_STANDARD_FLAGS_GNU}" CACHE STRING "C++ flags used for compiling private BLAKE3 library components with GNU-like compiler frontends.")
  set(BLAKE3_CXXFLAGS_MSVC "/EHs-c-;/GR-;${BLAKE3_CXX_STANDARD_FLAGS_MSVC}" CACHE STRING "C++ flags used for compiling private BLAKE3 library components with MSVC-like compiler frontends.")

  if(BLAKE3_CXX_COMPILER_FRONTEND_VARIANT STREQUAL "GNU")
    target_compile_options(blake3 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${BLAKE3_CXXFLAGS_GNU}>)
  elseif(BLAKE3_CXX_COMPILER_FRONTEND_VARIANT STREQUAL "MSVC")
    target_compile_options(blake3 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${BLAKE3_CXXFLAGS_MSVC}>)
  endif()

  # Undefine scratch variables
  unset(BLAKE3_CXX_STANDARD_FLAGS_GNU)
  unset(BLAKE3_CXX_STANDARD_FLAGS_MSVC)
  unset(BLAKE3_CXXFLAGS_GNU)
  unset(BLAKE3_CXXFLAGS_MSVC)
endif()

# cmake install support
install(FILES blake3.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(TARGETS blake3 EXPORT blake3-targets
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
)
install(EXPORT blake3-targets
  NAMESPACE BLAKE3::
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/blake3"
)

include(CMakePackageConfigHelpers)
configure_package_config_file(blake3-config.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/blake3-config.cmake"

    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/blake3"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/blake3-config-version.cmake"
    VERSION ${libblake3_VERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/blake3-config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/blake3-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/blake3"
)

# Function for joining paths known from most languages
#
# SPDX-License-Identifier: (MIT OR CC0-1.0)
# Copyright 2020 Jan Tojnar
# https://github.com/jtojnar/cmake-snips
#
# Modelled after Python’s os.path.join
# https://docs.python.org/3.7/library/os.path.html#os.path.join
# Windows not supported
function(join_paths joined_path first_path_segment)
    set(temp_path "${first_path_segment}")
    foreach(current_segment IN LISTS ARGN)
        if(NOT ("${current_segment}" STREQUAL ""))
            if(IS_ABSOLUTE "${current_segment}")
                set(temp_path "${current_segment}")
            else()
                set(temp_path "${temp_path}/${current_segment}")
            endif()
        endif()
    endforeach()

=== debian/changelog ===
rust-coreutils (0.6.0-1) unstable; urgency=medium

  * New upstream release
  * Vendor dependencies. Too hard to maintain in Debian
  * Update lintian override info format in d/source/lintian-overrides

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 Feb 2026 13:48:51 +0100

rust-coreutils (0.0.30-4) unstable; urgency=medium

  * Team upload.

  [ Jeremy Bícha]
  * remove unused Build-Depends: librust-unix-socket-dev

  [ Peter Michael Green ]
  * Add patch for nix 0.30

 -- Peter Michael Green <plugwash@debian.org>  Tue, 30 Sep 2025 12:45:34 +0000

rust-coreutils (0.0.30-3) unstable; urgency=medium

  * Team upload.
  * Bump the notify dependency to v8

 -- NoisyCoil <noisycoil@debian.org>  Wed, 24 Sep 2025 19:38:04 +0200

rust-coreutils (0.0.30-3~exp1) experimental; urgency=medium

  * Also ship with b3sum (Closes: #1107092)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 02 Jun 2025 20:43:15 +0200

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo:native,
 rustc:native,
 python3-sphinx,
 libclang-dev,
 libselinux-dev
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export CARGO_PROFILE_RELEASE_DEBUG=true
export SKIP_UTILS=stdbuf
VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")
UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version|cut -d- -f1)

# Build a multicall binary instead of multiple binaries
# to reduce the storage footprint
export MULTICALL = y

%:
	dh $@ --buildsystem cargo

override_dh_auto_test:
	# for now, don't fail the build if tests are failing
	CARGO_HOME=$(CURDIR)/debian/cargo_home make PROFILE=release MULTICALL=$(MULTICALL) test||true

override_dh_auto_install:
	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian debian/cargo_registry --link-from-system
#use thin rather than full lto on 32-bit to avoid running out of address space.
ifeq ($(DEB_HOST_ARCH_BITS),32)
	sed -i 's/lto = true/lto = "thin"/' Cargo.toml
endif
	CARGO_HOME=$(CURDIR)/debian/cargo_home DESTDIR=$(CURDIR)/debian/tmp/ make SELINUX_ENABLED=1 PROFILE=release MULTICALL=$(MULTICALL) install
ifeq ($(DEB_HOST_ARCH_BITS),32)
	sed -i 's/lto = "thin"/lto = true/' Cargo.toml
endif
# Create the symlink early to be able to generate the manpages
	cd debian/tmp/usr/share/zsh/site-functions && mkdir rust-coreutils && chmod -x _* && mv _* rust-coreutils
	cd debian/tmp/usr/share/bash-completion/completions/ && chmod -x rust-*
	cd debian/tmp/usr/share/fish/vendor_completions.d/ && chmod -x *.fish
	cd debian/tmp/usr/bin && mv rust-coreutils coreutils && rm rust-*
#	cd debian/tmp/usr/share/fish/vendor_completions.d && for f in *fish; do mv $$f rust-$$f; done
	dh_link

override_dh_missing:
	dh_missing --fail-missing

override_dh_dwz:
	# Don't do anything. fails because of the
	# https://github.com/rust-lang/rust/issues/66118

#use lower debuginfo level on 32-bit to avoid running out of address space.
ifeq ($(DEB_HOST_ARCH_BITS),32)
execute_after_dh_auto_configure:
	if test -f debian/cargo_home/config; then \
		sed -i s/debuginfo=2/debuginfo=1/ debian/cargo_home/config; \
	fi
endif

override_dh_clean:
	rm -f Cargo.toml.orig Cargo.lock
	dh_clean --exclude=Cargo.toml.orig --exclude=config.guess

override_dh_update_autotools_config:
	# don't do anything - impact vendoring otherwise
